From 284a58468a38bafcda227aeb9897c2da98d14c19 Mon Sep 17 00:00:00 2001
From: Eric Barbour <ebarbour@redhat.com>
Date: Aug 10 2016 19:35:20 +0000
Subject: [PATCH 619/1001] Escape html in fedmsgs and remove More dropdown


* Update saved when changing to that tab

---

diff --git a/hubs/static/client/app/components/Dropdown.jsx b/hubs/static/client/app/components/Dropdown.jsx
index 57de016..47511f7 100644
--- a/hubs/static/client/app/components/Dropdown.jsx
+++ b/hubs/static/client/app/components/Dropdown.jsx
@@ -15,8 +15,9 @@ export default class Dropdown extends React.Component {
       data: JSON.stringify(payload),
       contentType: 'application/json',
     }).done(() => {
-      const id = '#save-' + this.props.match.dom_id;
+      const id = `#save-${this.props.match.dom_id}`;
       const $saveBtn = $(id);
+      $saveBtn.removeClass('btn-primary').addClass('btn-success');
       $saveBtn.text('Saved');
     });
   }
@@ -25,29 +26,20 @@ export default class Dropdown extends React.Component {
     let saveBtn;
     if (!this.props.match.saved && this.props.saveUrl) {
       saveBtn = (
-        <a
-          className="dropdown-item"
+        <button
+          id={`save-${this.props.match.dom_id}`}
+          className="btn btn-sm btn-primary"
           onClick={this.onClick.bind(this)}
           href="#"
         >
           Save
-        </a>
+        </button>
       );
     }
 
     return (
-      <div className="dropdown pull-sm-right">
-        <span
-          className="dropdown-toggle" type="button"
-          id={'save-' + this.props.match.dom_id}
-          data-toggle="dropdown" aria-haspopup="true"
-          aria-expanded="true"
-        >
-          More
-        </span>
-        <div className="dropdown-menu" aria-labelledby="dropdownMenu2">
-          {saveBtn}
-        </div>
+      <div className="pull-right">
+       {saveBtn}
       </div>
     );
   }
diff --git a/hubs/static/client/app/components/Feed.jsx b/hubs/static/client/app/components/Feed.jsx
index 4562dcd..4d6c9d2 100644
--- a/hubs/static/client/app/components/Feed.jsx
+++ b/hubs/static/client/app/components/Feed.jsx
@@ -1,5 +1,5 @@
 import React from 'react';
-import { render } from 'react-dom';
+import ReactDOM from 'react-dom';
 
 import Panel from './Panel.jsx';
 
@@ -46,4 +46,4 @@ export default class Feed extends React.Component {
 
 window.Feed = Feed;
 window.React = React;
-window.reactRender = render;
+window.ReactDOM = ReactDOM;
diff --git a/hubs/stream.py b/hubs/stream.py
index 2cbcadf..8c33bf2 100644
--- a/hubs/stream.py
+++ b/hubs/stream.py
@@ -1,3 +1,4 @@
+import cgi
 import datetime
 import json
 import uuid
@@ -100,6 +101,7 @@ class Stream(object):
                 **fmn_hinting)
             messages.extend(rows)
 
+
         for message in messages:
             original = message.__json__()
             if self.name in fedmsg.meta.msg2usernames(original, **
@@ -117,10 +119,21 @@ class Stream(object):
 
         return preference
 
+    def escape_html(self, match):
+        for key in ['subjective', 'subtitle']:
+            match[key] = cgi.escape(match[key])
+        try:
+            match['long_form'] = cgi.escape(match['long_form'])
+        except:
+            # not all matches have a long form
+            pass
+        return match
+
     def apply_markup(self, match):
+        match = self.escape_html(match)
         markup = match['subtitle']
         for username in match['usernames']:
-            args = (username, '<a href="{url}">@{username}</a>'.format(
+            args = (username, '<a href="{url}" rel="nofollow">@{username}</a>'.format(
                 url=flask.url_for('hub', name=username),
                 username=username, ))
             markup = markup.replace(*args)
